%global momorel 4
%global version 2.1.9

Summary: Mailing list manager with built in Web access.
Name: mailman
Version: %{version}
Release: %{momorel}m%{?dist}
License: GPL
Group: Applications/Internet
URL: http://www.list.org/
Source0: http://dl.sourceforge.net/sourceforge/mailman/mailman-%{version}.tgz 
NoSource: 0
#Source0: ftp://ftp.gnu.org/pub/gnu/mailman/mailman-%{version}.tgz
#NoSource: 0
Source1: mm_cfg.py
Source3: httpd-mailman.conf
Source4: mailman.logrotate
Source5: mailman.INSTALL.REDHAT.in
Source6: mailman-crontab-edit
Source7: mailman-migrate-fhs
Patch1: mailman-2.1-multimail.patch
Patch2: mailman-2.1-build.patch
Patch3: mailman-2.1-mailmanctl-status.patch
Patch4: mailman-cron.patch
Patch5: mailman-FHS.patch
Patch6: mailman-python-compile.patch
Patch7: mailman-init.patch
# Patch10: mailman-2.1.5-date_overflows.patch (CVE-2005-3573)

# JP patch
# http://mm.tkikuchi.net/indexja-old.html
#Patch10: mailman-2.1.5+patch.20040901.gz

Patch20: mailman-2.1.9-dont-import-japanese.patch

BuildRoot: %{_tmppath}/%{name}-%{version}-%{release}-root-%(%{__id_u} -n)

PreReq: shadow-utils, chkconfig, initscripts
Requires: vixie-cron >= 4.1, webserver, python >= 2.2, mktemp
BuildPrereq: python-devel >= 2.2
Conflicts: fml

%global contentdir /var/www

# Installation directories
%global mmdir /usr/lib/%{name}
%global varmmdir /var/lib/%{name}
%global docdir /usr/share/doc/%{name}-%{version}
%global configdir /etc/%{name}
%global datadir %{varmmdir}/data
%global lockdir /var/lock/%{name}
%global logdir /var/log/%{name}
%global piddir /var/run/%{name}
%global queuedir /var/spool/%{name}
%global httpdconfdir /etc/httpd/conf.d
%global restart_flag /var/run/%{name}-restart-after-rpm-install
%global mmbuilddir %{_builddir}/%{name}-%{version}

%global httpdconffile %{name}.conf.dist

# Now, the user and group the CGIs will expect to be run under.  This should
# match the user and group the web server is configured to run as.  The scripts
# will error out if they are invoked by any other user.
%global cgiuser    apache
%global cgigroup   apache

# Now, the user and group the scripts will actually execute as.
%global mmuser       mailman
%global mmuserid     41
%global mmgroup      mailman
%global mmgroupid    41

# Directory/File modes & permissions
%global dirmode 2775
%global exemode 2755

# Now, the groups your mail spoolers run as.  Sendmail uses 'mail'(12)
# and postfix used to use 'nobody', but now uses 'postfix'
%global mailgroup  "mail postfix mailman nobody daemon"

# The mail wrapper program
%global mail_wrapper mailman

%description 
Mailman is software to help manage email discussion lists, much like
Majordomo and Smartmail. Unlike most similar products, Mailman gives
each mailing list a webpage, and allows users to subscribe,
unsubscribe, etc. over the Web. Even the list manager can administer
his or her list entirely from the Web. Mailman also integrates most
things people want to do with mailing lists, including archiving, mail
<-> news gateways, and so on.

Documentation can be found in: %{docdir}

When the package has finished installing, you will need to perform some
additional installation steps, these are described in:
%{docdir}/INSTALL.REDHAT

%prep
%setup -q
%patch1 -p1 -b .multimail
%patch2 -p1 -b .permissions
%patch3 -p1 -b .status
%patch4 -p1 -b .cron
%patch5 -p1 -b .FHS
%patch6 -p1 -b .python-compile
%patch7 -p1 -b .inithelp

%patch20 -p1 -b .dont-import-japanese

cp %{_sourcedir}/mailman.INSTALL.REDHAT.in INSTALL.REDHAT.in

%build

CFLAGS="%{optflags}"; export CFLAGS
rm -f ./configure
aclocal
autoconf
./configure \
	--prefix=%{mmdir} \
	--with-var-prefix=%{varmmdir} \
	--with-config-dir=%{configdir} \
	--with-lock-dir=%{lockdir} \
	--with-log-dir=%{logdir} \
	--with-pid-dir=%{piddir} \
	--with-queue-dir=%{queuedir} \
	--with-python=%{__python} \
	--with-mail-gid=%{mailgroup} \
	--with-cgi-id=%{cgiuser} \
	--with-cgi-gid=%{cgigroup} \
	--with-mailhost=localhost.localdomain \
	--with-urlhost=localhost.localdomain \
	--without-permcheck

function SubstituteParameters()
{
sed -e 's|@VAR_PREFIX@|%{varmmdir}|g' \
    -e 's|@VARMMDIR@|%{varmmdir}|g' \
    -e 's|@prefix@|%{mmdir}|g' \
    -e 's|@MMDIR@|%{mmdir}|g' \
    -e 's|@CONFIG_DIR@|%{configdir}|g' \
    -e 's|@DATA_DIR@|%{datadir}|g' \
    -e 's|@LOCK_DIR@|%{lockdir}|g' \
    -e 's|@LOG_DIR@|%{logdir}|g' \
    -e 's|@PID_DIR@|%{piddir}|g' \
    -e 's|@QUEUE_DIR@|%{queuedir}|g' \
    -e 's|@DOC_DIR@|%{docdir}|g' \
    -e 's|@HTTPD_CONF_DIR@|%{httpdconfdir}|g' \
    -e 's|@HTTPD_CONF_FILE@|%{httpdconffile}|g' \
    $1 > $2
}

SubstituteParameters "INSTALL.REDHAT.in" "INSTALL.REDHAT"
SubstituteParameters "%{SOURCE1}" "Mailman/mm_cfg.py.dist"
SubstituteParameters "%{SOURCE3}" "httpd-mailman.conf"
SubstituteParameters "%{SOURCE4}" "mailman.logrotate"

%make
	
%install
rm -fr --preserve-root %{buildroot}
# Normal install.
make DESTDIR=%{buildroot} install
#make install prefix=%{buildroot}%{mmdir} var_prefix=%{buildroot}%{varmmdir}

# Install the mailman init.d script
mkdir -p %{buildroot}%{_initscriptdir}
install %{buildroot}%{mmdir}/scripts/mailman %{buildroot}%{_initscriptdir}/mailman

# Install the mailman cron.d script
mkdir -p %{buildroot}/etc/cron.d
cat > %{buildroot}/etc/cron.d/%{name} <<EOF
# DO NOT EDIT THIS FILE!
#
# Contents of this file managed by /etc/init.d/%{name}
# Master copy is %{mmdir}/cron/crontab.in
# Consult that file for documentation
EOF

# Copy the icons into the web server's icons directory.
mkdir -p %{buildroot}%{contentdir}/icons
cp %{buildroot}/%{mmdir}/icons/* %{buildroot}%{contentdir}/icons

# Create a link to the wrapper in /etc/smrsh to allow sendmail to run it.
mkdir -p %{buildroot}/etc/smrsh
ln -s %{mmdir}/mail/%{mail_wrapper} %{buildroot}/etc/smrsh

# Create a link so that the config file mm_cfg.py appears in config
# directory /etc/mailman. We don't put mm_cfg.py in the config directory
# because its executable code (python file) and the security policy wants
# to keep executable code out of /etc and inside of a lib directory instead,
# and because traditionally mm_cfg.py was in the Mailman subdirectory and
# experienced mailman admins will expect to find it there. But having it 
# "appear" in the config directory is good practice and heading in the 
# right direction for FHS compliance.
mkdir -p %{buildroot}%{configdir}
ln -s %{mmdir}/Mailman/mm_cfg.py %{buildroot}%{configdir}

# sitelist.cfg used to live in the DATA_DIR, now as part of the 
# FHS reoraganization it lives in the CONFIG_DIR. Most of the
# documentation refers to it in its DATA_DIR location and experienced
# admins will expect to find it there, so create a link in DATA_DIR to
# point to it in CONFIG_DIR so people aren't confused.
ln -s %{configdir}/sitelist.cfg %{buildroot}%{datadir}

# Install a logrotate control file.
mkdir -p %{buildroot}/etc/logrotate.d
install -m644 %{mmbuilddir}/%{name}.logrotate %{buildroot}/etc/logrotate.d/%{name}

# Install the httpd configuration file.
install -m755 -d %{buildroot}%{httpdconfdir}
install -m644 %{mmbuilddir}/httpd-mailman.conf %{buildroot}%{httpdconfdir}/%{httpdconffile}

# Install the documentation files
install -m755 -d %{buildroot}%{docdir}
install -m644 %{mmbuilddir}/INSTALL.REDHAT   %{buildroot}%{docdir}
install -m644 %{mmbuilddir}/ACKNOWLEDGMENTS  %{buildroot}%{docdir}
install -m644 %{mmbuilddir}/FAQ              %{buildroot}%{docdir}
install -m644 %{mmbuilddir}/NEWS             %{buildroot}%{docdir}
install -m644 %{mmbuilddir}/README           %{buildroot}%{docdir}
install -m644 %{mmbuilddir}/README.CONTRIB   %{buildroot}%{docdir}
install -m644 %{mmbuilddir}/README-I18N.en   %{buildroot}%{docdir}
install -m644 %{mmbuilddir}/README.NETSCAPE  %{buildroot}%{docdir}
install -m644 %{mmbuilddir}/README.USERAGENT %{buildroot}%{docdir}
install -m644 %{mmbuilddir}/STYLEGUIDE.txt   %{buildroot}%{docdir}
install -m644 %{mmbuilddir}/UPGRADING        %{buildroot}%{docdir}

cp -r %{mmbuilddir}/contrib %{buildroot}%{docdir}
install -m644 %{_sourcedir}/mailman-migrate-fhs %{buildroot}%{docdir}/contrib/migrate-fhs
install -m755 -d %{buildroot}%{docdir}/admin
cp -r %{mmbuilddir}/admin/www %{buildroot}%{docdir}/admin

# remove dir/files from %{buildroot} that we aren't shipping
rm -rf %{buildroot}%{varmmdir}/icons

# The file fblast confuses /usr/lib/rpm/find-requires because its an executable
# script file that does not have the interpreter as the first line, its not
# executable by itself so turn off its execute permissions
chmod 0644 %{buildroot}/%{mmdir}/tests/fblast.py

%clean
rm -fr --preserve-root %{buildroot}
rm -rf %{_builddir}/files.%{name}

%pre

# Make sure the user "mailman" exists on this system and has the correct values
if grep -q "^mailman:" /etc/group 2> /dev/null ; then
  /usr/sbin/groupmod -g %{mmgroupid} -n %{mmgroup} %{mmgroup} 2> /dev/null || :
else
  /usr/sbin/groupadd -g %{mmgroupid} %{mmgroup} 2> /dev/null || :
fi
if grep -q "^mailman:" /etc/passwd 2> /dev/null ; then
  /usr/sbin/usermod -s /sbin/nologin -c "GNU Mailing List Manager" -d %{mmdir} -u %{mmuserid} -g %{mmgroupid}       %{mmuser} 2> /dev/null || :
else
  /usr/sbin/useradd -s /sbin/nologin -c "GNU Mailing List Manager" -d %{mmdir} -u %{mmuserid} -g %{mmgroupid} -M -r %{mmuser} 2> /dev/null || :
fi

# Mailman should never be running during an install, but a package upgrade
# shouldn't silently stop the service, so if mailman was running
# we'll leave a temp file in the lock directory as a flag so in
# the post install phase we can restart it.
if [ -d %{lockdir} ]; then
  rm -f %{restart_flag}
  /sbin/service %{name} status >/dev/null 2>&1
  if [ $? -eq 0 ]; then
      touch %{restart_flag}
      /sbin/service %{name} stop >/dev/null 2>&1
  fi
fi
# rpm should not abort if last command run had non-zero exit status, exit cleanly
exit 0

%post
# We no longer use crontab, but previous versions of the spec file did, so clean up
if [ -f /var/spool/cron/%{mmuser} ]; then
  crontab -u %{mmuser} -r
fi

# This adds the proper /etc/rc*.d links for the script that runs the mailman qrunner daemon
/sbin/chkconfig --add mailman

# Restart mailman if it had been running before installation
if [ -e %{restart_flag} ]; then
  rm %{restart_flag}
  /sbin/service %{name} start >/dev/null 2>&1
fi
# rpm should not abort if last command run had non-zero exit status, exit cleanly
exit 0

%preun

# if [ $1 = 0 ]' checks that this is the actual deinstallation of
# the package, as opposed to just removing the old package on upgrade.

if [ $1 = 0 ]; then
  # These statements stop the service, and remove the /etc/rc*.d links.
  /sbin/service %{name} stop >/dev/null 2>&1
  /sbin/chkconfig --del %{name}
fi
# rpm should not abort if last command run had non-zero exit status, exit cleanly
exit 0

%postun

if [ $1 = 0 ]; then
  crontab -u %{mmuser} -r
fi
# rpm should not abort if last command run had non-zero exit status, exit cleanly
exit 0

%files
%defattr(-,root,%{mmgroup})
%dir %{mmdir}
%{mmdir}/Mailman
%{mmdir}/bin
%{mmdir}/cgi-bin
%{mmdir}/cron
%{mmdir}/icons
%{mmdir}/mail
%{mmdir}/messages
%{mmdir}/pythonlib
%{mmdir}/scripts
%config(noreplace) %{mmdir}/templates
%{mmdir}/tests
%{varmmdir}
%attr(-,root,root) %doc %{docdir}
#%%attr(0755,root,root) %{contentdir}/icons
%{contentdir}/icons/*
%attr(0644, root, %{mmgroup}) %config(noreplace) %verify(not md5 size mtime) %{mmdir}/Mailman/mm_cfg.py
%config(noreplace) %{httpdconfdir}/%{httpdconffile}
/etc/logrotate.d/%{name}
/etc/smrsh/%{mail_wrapper}
%attr(2775,root,%{mmgroup}) %{configdir}
%attr(0644, root, %{mmgroup}) %config(noreplace) %verify(not md5 size mtime) %{configdir}/sitelist.cfg
%attr(2775,root,%{mmgroup}) %{lockdir}
%attr(2775,root,%{mmgroup}) %{logdir}
%attr(2775,root,%{mmgroup}) %{queuedir}
%attr(2775,root,%{mmgroup}) %{piddir}
%attr(0755,root,root) %{_initscriptdir}/%{name}
%attr(0644,root,root) %config(noreplace) %verify(not md5 size mtime) /etc/cron.d/mailman
%attr(0644,root,%{mmgroup}) %config(noreplace) %{mmdir}/cron/crontab.in

%changelog
* Thu Apr 03 2008 TABUCHI Takaaki <tab@momonga-linux.org>
- (2.1.9-4m)
- rebuild against gcc43

* Thu Feb 14 2008 Yohsuke Ooi <meke@momonga-linux.org>
- (2.1.9-3m)
- %%NoSource -> NoSource

* Fri Dec 29 2006 KAJIWARA, Atsushi <kajiwara@noguard.org>
- (2.1.9-2m)
- add mailman-2.1.9-dont-import-japanese.patch
- see <http://mm.tkikuchi.net/pipermail/mmjp-users/2006-October/001882.html>

* Thu Sep 13 2006 KAJIWARA, Atsushi <kajiwara@noguard.org>
- (2.1.9-1m)
- version up 2.1.9
- [SECURITY] CVE-2006-2191 CVE-2006-2941 CVE-2006-3636 CVE-2006-4624
- http://secunia.com/advisories/21732/

* Thu Sep 07 2006 KAJIWARA, Atsushi <kajiwara@noguard.org>
- (2.1.9-0.1.1m)
- version up 2.1.9rc1
- [SECURITY] CVE-2006-2941 CVE-2006-3636
- http://secunia.com/advisories/21732/

* Fri Jun 09 2006 TABUCHi Takaaki <tab@momonga-linux.org>
- (2.1.8-2m)
- delete dup dir between httpd (/var/www/icons/)

* Sun Apr 16 2006 Ryu SASAOKA <ryu@momonga-linux.org>
- (2.1.8-1m)
- update to 2.1.8 
- [SECURITY] CVE-2006-1712
- http://mail.python.org/pipermail/mailman-announce/2006-April/000084.html

* Wed Mar  1 2006 KAJIWARA, Atsushi <kajiwara@noguard.org>
- (2.1.7-2m)
- fix /etc/logrotate.d/mailman

* Thu Feb 23 2006 Hiroyuki Koga <kuma@momonga-linux.org>
- (2.1.7-1m)
- bugfix release

* Wed Jun  1 2005 Hiroyuki Koga <kuma@momonga-linux.org>
- (2.1.6-1m)
- include security features

* Wed Apr  6 2005 Hiroyuki Koga <kuma@momonga-linux.org>
- (2.1.5-3m)
- fix attribution of docdir

* Thu Mar 17 2005 Hiroyuki Koga <kuma@momonga-linux.org>
- (2.1.5-2m)
- [SECURITY] CAN-2005-0202

* Sun Feb 13 2005 Hiroyuki Koga <kuma@momonga-linux.org>
- (2.1.5-1m)
- import from FC3
- add jp patch (include Patch4)
